import os
import sys
import thread

try:
    raise Exception
except Exception:
    path = sys.exc_info()[2].tb_frame.f_code.co_filename

dirname, filename = os.path.split(path)
sys.path.append(dirname)

import appuifw
import e32

from twisted.web import proxy, http
from twisted.internet import reactor

class ProxyRequest(proxy.ProxyRequest):
    def process(self):
        self.received_headers['user-agent'] = \
            'Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 6.0)'
        proxy.ProxyRequest.process(self)

def exit_key_handler():
    app_lock.signal()
    reactor.stop()

def start_reactor(reactor):
    reactor.run()

factory = http.HTTPFactory()
factory.protocol = proxy.Proxy
factory.protocol.requestFactory = ProxyRequest
reactor.listenTCP(8050, factory)
t = thread.start_new_thread(start_reactor, (reactor,))

content = appuifw.Text()
appuifw.app.title = u'User-Agent Proxy'
appuifw.app.body = content
appuifw.app.exit_key_handler = exit_key_handler
content.add(u'Listening on port 127.0.0.1:8050')

app_lock = e32.Ao_lock()
app_lock.wait()

